.BG
.FN compress
.TL
Bin Data Before Using "ashn" Function
.DN
Each data vector is transformed to a bin vector.
(Currently, real compression is not performed.)
.CS
compress(x, ab=t(apply(x,2,nicerange)), nbin=rep(30,ncol(x)))
.RA
.AG x
matrix (n x d) of data values x,
where the number of variables d>2.
.OA
.AG ab
(d x 2 matrix)  The i-th row contains bin intervals
for the i-th variable.  Default value is the sample
range padded 5% on each extreme.
.AG nbin
vector of length d containing the
number of bins along the axes. Default is rep(30,d). 
.RT
a list suitable for input to "ashn" containing:
.RC nc
matrix of data in binned form.
.RC ab
the input binning intervals.
.RC nbin
the input number of bins.
.SE
Data falling outside "ab" are ignored for estimation purposes.
.SH REFERENCES
Scott, D.W. (1985).  "Averaged Shifted Histograms:
Effective Nonparametric Density Estimators in Several Dimensions."
Annals of Statistics, 80, 348-354.
.PP
Scott, D.W. (1992).  Multivariate Density Estimation:
Theory, Practice, and Visualization.
John Wiley & Sons, New York.
.SA
ashn, bin1, ash1, bin2, ash2, density, ksmooth
.EX
xyz <- compress( matrix(rnorm(3000),1000,3) )
.KW ash, kernel, density, histogram, binning, ashn
.WR
