#include <stdio.h>
struct connection {
  int n, start[5], end[5];
} C[5] [5] ={
  {{0},{3,{0,0,0},{1,2,3}},{4,{0,2,1,3},{2,1,3,0}},{3,{3,3,3},{0,1,2}},{0}},
  {{0},{3,{0,0,1},{2,3,1}},{3,{0,1,2},{3,3,2}},{0},{0}},
  {{0},{3,{0,1,2},{3,1,2}},{0},{0},{0}},
  {{3,{0,1,2},{0,1,2}},{3,{1,2,3},{1,2,3}},{0},{0},{0}},
  {{0},{0},{0},{0},{0}}
};

simpint(P, F, X)
float **P, *F, **X;
{
	float *p[4], f[4];
	int ord[4], nneg, nzero, nvertex, orientation, i, j;
	struct connection c;

	sort4(F, ord);
	nneg = nzero = 0;
	for(i = 0; i < 4; i++) {
		p[i] = P[ord[i]];
		f[i] = F[ord[i]];
		nneg += f[i] < 0;
		nzero += f[i] == 0;
	}
	c = C[nzero][nneg];
	nvertex = c.n;
	if(nvertex == 0)
		return(0);
	for(i = 0; i < nvertex; i++) {
		int u = c.start[i], v = c.end[i], w;
		double a;

		if(u == v)
			for(j = 0; j < 3; j++)
				X[i][j] = p[u][j];
		else {
			if(f[u] < 0) {w = u; u = v; v = w;}
			a = f[u] / (f[u] - f[v]);
			for(j = 0; j < 3; j++)
				X[i][j] = (1 - a) * p[u][j] + a * p[v][j];
		}
	}
	if(nneg)
		orientation = which_side(X[0], X[1], X[2], p[0]);
	else
		orientation = -which_side(X[0], X[1], X[2], p[3]);
	if(orientation < 0) {
		float *tmp[4];
		for(i = 0; i < nvertex; i++)
			tmp[i] = X[i];
		for(i = 0; i < nvertex; i++)
			X[i] = tmp[nvertex-i-1];
	}
	return(nvertex);
}

#define ORDER(p,q,r)	{o[0]=p; o[1]=q; o[2]=r;}

sort4(a, o)
float *a;
int *o;
{
	int i, j;

	if(a[0] < a[1])
		if(a[2] < a[0])		ORDER(2,0,1)
		else if(a[2] > a[1])	ORDER(0,1,2)
		else			ORDER(0,2,1)
	else
		if(a[2] < a[1])		ORDER(2,1,0)
		else if(a[2] > a[0])	ORDER(1,0,2)
		else			ORDER(1,2,0)
	for(i = 0; i < 3; i++)
		if(a[3] < a[o[i]])
			break;
	for(j = 3; j > i; j--)
		o[j] = o[j-1];
	o[i] = 3;
}

which_side(x0, x1, x2, p)
float *x0, *x1, *x2, *p;
{
	int i;
	float v1[3], v2[3], v[3], cross[3], dot;

	for(i = 0; i < 3; i++) {
		v1[i] = x2[i] - x1[i];
		v2[i] = x0[i] - x1[i];
		v[i] = p[i] - x1[i];
	}
	cross[0] = v1[1]*v2[2] - v1[2]*v2[1];
	cross[1] = v1[2]*v2[0] - v1[0]*v2[2];
	cross[2] = v1[0]*v2[1] - v1[1]*v2[0];
	dot = 0;
	for(i = 0; i < 3; i++)
		dot += cross[i] * v[i];
	return(dot > 0 ? 1 : -1);
}

