#include <stdio.h>
#include "S.h"

static FILE *f = NULL;

F77_SUB(startwrite) (n)
long *n;
{
	char filename[20];

	sprintf(filename, "fig.%d.quad", *n);
	f = fopen(filename, "w");
	if(f == NULL)
		fprintf(stderr, "cannot create %s for writing\n", filename);
	fprintf(f, "CQUAD\n");
}

#define VEC(x, m)				\
{						\
	for(k = 0; k < m; k++)			\
		fprintf(f, " %g", x[k]);	\
	for(k = 0; k < 4; k++)			\
		fprintf(f, " %g", color[k]);	\
	fprintf(f, "\n");			\
}

static float b0[3] = {1,0,0}, b1[3] = {0,1,0}, b2[3] = {0,0,1};
static float *basis[3] = {b0, b1, b2};

F77_SUB(docube) (origin, cube_size, values, contour, color)
float *origin, *cube_size, *values, *contour, *color;
{
	int i, j, k, size[6], npatch;
	float x[72], *points[24], **patch, F[8];

	if(f == NULL)
		return;
	for(i = 0; i < 3; i++)
		basis[i][i] = cube_size[i];
	for(i = 0; i < 8; i++)
		F[i] = values[i] - *contour;
	for(i = 0; i < 24; i++)
		points[i] = x + 3*i;
	npatch = cubeint(origin, basis, F, points, size);
	patch = points;
	for(i = 0; i < 6; i++) {
		if(size[i] == 0)
			continue;
		for(j = 0; j < size[i]; j++)
			VEC(patch[j], 3)
		if(size[i] == 3)
			VEC(patch[0], 3)
		fprintf(f, "\n");
		patch += size[i];
	}
}

F77_SUB(endwrite) ()
{
	if(f != NULL)
		fclose(f);
}

